<?php
/* 
Menu.php for Dropline menu
Copyright (C) 2008 TemplatePlazza.com
All rights reserved.
 */ 
 
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
ini_set('arg_separator.output','&amp;');

class Menu {
  var $_menuname;
  var $_openall;
  var $_start;
  var $_end;
  var $_open;
  var $_menu_name;
  var $_output;
  var $_indents;

	var $_display_image_on_top_menu_dropline;
	var $_display_image_with_text_on_top_menu_dropline;
	var $_image_position_on_top_menu_dropline;
	
	var $_display_image_on_sub_menu_dropline;
	var $_display_image_with_text_on_sub_menu_dropline;
	var $_image_position_on_sub_menu_dropline;

	var $_image_suffix_hover;
		  
  function Menu($dataMenu) {
    $this->_menuname = $dataMenu["menuname"];
    $this->_openall = $dataMenu["openall"];
    $this->_start = 1;
    $this->_end = 3;
    $this->_open = array();
    $this->_indents = array(array( "<ul>", "<li>" , "</li>", "</ul>" ),	);
    $this->_menu_name = '';

		$this->_display_image_on_top_menu_dropline = $dataMenu["display_image_on_top_menu_dropline"];
		$this->_display_image_with_text_on_top_menu_dropline = $dataMenu["display_image_with_text_on_top_menu_dropline"];
		$this->_image_position_on_top_menu_dropline = $dataMenu["image_position_on_top_menu_dropline"];
		$this->_display_image_on_sub_menu_dropline = $dataMenu["display_image_on_sub_menu_dropline"];
		$this->_display_image_with_text_on_sub_menu_dropline = $dataMenu["display_image_with_text_on_sub_menu_dropline"];
		$this->_image_position_on_sub_menu_dropline = $dataMenu["image_position_on_sub_menu_dropline"];

		$this->_image_suffix_hover = $dataMenu["image_suffix_hover"];
    
   	global $database, $my, $cur_template, $Itemid;
   	global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_shownoauth;

   	$hilightid = null;
   	$startid = 0;
   	if ($mosConfig_shownoauth) {
      $database->setQuery("SELECT m.*, count(p.parent) as cnt" .
      "\nFROM #__menu AS m" .
      "\nLEFT JOIN #__menu AS p ON p.parent = m.id" .
      "\nWHERE m.menutype='$this->_menuname' AND m.published='1'" .
      "\nGROUP BY m.id ORDER BY m.parent, m.ordering ");
    } else {
      $database->setQuery("SELECT m.*, sum(case when p.published=1 then 1 else 0 end) as cnt" .
      "\nFROM #__menu AS m" .
      "\nLEFT JOIN #__menu AS p ON p.parent = m.id" .
      "\nWHERE m.menutype='$this->_menuname' AND m.published='1' AND m.access <= '$my->gid'" .
      "\nGROUP BY m.id ORDER BY m.parent, m.ordering ");
    }

   	$rows = $database->loadObjectList( 'id' );
   	echo $database->getErrorMsg();
  	
    // fix weird problem with itemid undefined
   	if ($Itemid > 999999) { 
   	  $current = current($rows);
   	  $Itemid = $current->id; 
   	}
   	
   	//work out if this should be highlighted
   	$sql = "SELECT m.* FROM #__menu AS m"
   	. "\nWHERE menutype='". $this->_menuname ."' AND m.published='1'"; 
   	$database->setQuery( $sql );
   	$subrows = $database->loadObjectList( 'id' );
   	$maxrecurse = 5;
   	$parentid = $Itemid;

   	//this makes sure toplevel stays hilighted when submenu active
   	while ($maxrecurse-- > 0) {
   		$parentid = $this->getTheParentRow($subrows, $parentid);
   		if (isset($parentid) && $parentid >= 0 && $subrows[$parentid]) {
   			$hilightid = $parentid;
   		} else {
   			break;	
   		}
   	}	
    // establish the hierarchy of the menu
   	$children = array();

    // first pass - collect children
    foreach ($rows as $v ) {
  		$pt = $v->parent;
   		$list = @$children[$pt] ? $children[$pt] : array();
   		array_push( $list, $v );

      $children[$pt] = $list;
    }

    // second pass - collect 'open' menus
  	$this->_open = array( $Itemid );
   	$count = 20; // maximum levels - to prevent runaway loop
   	$id = $Itemid;
   	while (--$count) {
   		if (isset($rows[$id]) && $rows[$id]->parent > 0) {
   			$id = $rows[$id]->parent;
   			$this->_open[] = $id;
   		} else {
   			break;
   		}
   	}
   	
    //get the name of the parent node
 	  $parentopen = array_reverse($this->_open);
 	  if (array_key_exists($parentopen[0],$rows)) 
 	    $this->_menu_name = $rows[$parentopen[0]]->name;
   	
	  if ($this->_start > 1) $startid = $id;
	  $this->_output = $this->recurseListMenu( $startid, $this->_start, $children, $hilightid );
	  	  
    $pre = '<div id="tp-mainnavwrap"><div id="tp-mainnav" class="clearfix">';
    $post = '</div></div>';
           
    if (isset($this->_output)) {
       $this->_output = $pre . $this->_output . $post;
     } 
  }
  
  function recurseListMenu( $id, $level, &$children, $highlight ) {
  	global $Itemid;
  	global $HTTP_SERVER_VARS, $mosConfig_live_site;

  	$output = "";
  	$ulstyle = "";


  	if (@$children[$id] && $level < $this->_end) {
  		$n = min( $level, count( $this->_indents )-1 );

  		if($this->_start==$level) {
  		  $ulstyle .= ' class="clearfix" ';
  		} 
  		if($level==1) {
  		  $ulstyle .= ' id="tp-cssmenu"'; 
  		}
  		
  		$output .= "<ul" . $ulstyle . ">";

  		foreach ($children[$id] as $row) {

  		  switch ($row->type) {
       		case 'separator':
       		// do nothing
       		$row->link = "seperator";

       		break;

       		case 'url':
       		if ( eregi( 'index.php\?', $row->link ) ) {
      				if ( !eregi( 'Itemid=', $row->link ) ) {
      					$row->link .= '&Itemid='. $row->id;
      				}
      			}
       		break;

       		default:
       			$row->link .= "&Itemid=$row->id";

       		break;
       	}

        $class = "";
        $current_itemid = trim( mosGetParam( $_REQUEST, 'Itemid', 0 ) );
        $active_stat = false;
        if ($row->link != "seperator" 
  					&& $current_itemid == $row->id 
            || in_array($row->id,$this->_open)
  					|| $row->id == $highlight
          	|| (sefRelToAbs( substr($_SERVER['PHP_SELF'],0,-9) . $row->link)) == $_SERVER['REQUEST_URI']
          	|| (sefRelToAbs( substr($_SERVER['PHP_SELF'],0,-9) . $row->link)) == $HTTP_SERVER_VARS['REQUEST_URI']) {
  							$class .= "active ";
  							$active_stat = true;
  			}

  			if ($row->cnt > 0) {
  				$class .= "parent ";
  			}

		  	if($level == 1) {
		  		switch ($this->isFullImageMenu($row, $level)) {
			  		case 1:
				  		$class .= 'fulltpmenuimages ';
			  			break;
			  		case 2:
				  		$class .= 'tpmenutextandimage ';
			  			break;
			  	}
			  } else {
		  		switch ($this->isFullImageMenu($row, $level)) {
			  		case 1:
				  		$class .= 'fulltpmenuimageschild ';
			  			break;
			  		case 2:
				  		$class .= 'tpmenutextandimagechild ';
			  			break;
			  	}
			  }

  	    $output .= '<li class="' . trim($class) . '">' . "\n";

        $output .= $this->getLink( $row, $level, $active_stat );
        if ( $this->_openall || in_array( $row->id, $this->_open )) {
  			  $output .= $this->recurseListMenu( $row->id, $level+1, $children, "");
  		  }
        $output .= $this->_indents[$n][2];

      }
  		$output .= "\n".$this->_indents[$n][3];

  		return $output;

  	}
  }

  function getTheParentRow($rows, $id) {
		if (isset($rows[$id]) && $rows[$id]) {
  		if($rows[$id]->parent > 0) {
  			return $rows[$id]->parent;
  		}	
  	}
 		return -1;
	}

  function getLink( $mitem, $level, $active_stat ) {
  	global $Itemid, $mosConfig_live_site;
  	$txt = '';
  	$topdaddy = 'top';
  	
  	$mitem->link = str_replace( '&', '&amp;', $mitem->link );
  	$mitem->name = stripslashes( ampReplace($mitem->name) );

  	if (strcasecmp(substr($mitem->link,0,4),"http")) {
  		$mitem->link = sefRelToAbs($mitem->link);
  	}
  	 
    switch ($mitem->browserNav) {
  		case 1:
				$txt = "<a href=\"$mitem->link\" target=\"_window\" >".$this->show_image($mitem, $level, $active_stat)."</a>\n";
  			break;
  		case 2:
	  		$txt = "<a href=\"#\" onClick=\"javascript: window.open('$mitem->link', '', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=780,height=550');\">".$this->show_image($mitem, $level, $active_stat)."</a>\n";
	  		break;
  		case 3:
				$txt = "<a>".$this->show_image($mitem, $level, $active_stat)."</a>\n";
  			break;
  		default:	// formerly case 2
  		  $txt = "<a href=\"$mitem->link\">".$this->show_image($mitem, $level, $active_stat)."</a>";
	      break;
  	}
    return $txt;
  }

	function show_image($mitem, $level, $active_stat){
		global $Itemid,$mosConfig_live_site;
		$menu_params = new stdClass();
		$menu_params = new mosParameters( $mitem->params );
		$menu_image = $menu_params->def( 'menu_image', -1 );
		$active_image = ($active_stat == true)?$this->_image_suffix_hover:"";
		if ( ( $menu_image != '-1' ) && $menu_image && (strlen($menu_image)>0)) {
			$ima = explode(".", $menu_image);
			if($level == 1) {
				if($this->_display_image_on_top_menu_dropline == 1) {
					if($this->_display_image_with_text_on_top_menu_dropline == 1) {
						if($this->_image_position_on_top_menu_dropline == "left") {
							$image = '<img src="'. $mosConfig_live_site .'/images/stories/'. $ima[0] . $active_image . "." . $ima[1] . '" border="0" alt="'. $mitem->name . '" onmouseover="javascript:this.src=\'' .$mosConfig_live_site. '/images/stories/' . $ima[0] . $this->_image_suffix_hover . "." . $ima[1] . '\'" onmouseout="javascript:this.src=\'' .$mosConfig_live_site. '/images/stories/' . $ima[0] . $active_image . "." . $ima[1] . '\'" />' . $mitem->name;
						} else {
							$image = $mitem->name . '<img src="'. $mosConfig_live_site .'/images/stories/'. $ima[0] . $active_image . "." . $ima[1] . '" border="0" alt="'. $mitem->name . '" onmouseover="javascript:this.src=\'' .$mosConfig_live_site. '/images/stories/' . $ima[0] . $this->_image_suffix_hover . "." . $ima[1] . '\'" onmouseout="javascript:this.src=\'' .$mosConfig_live_site. '/images/stories/' . $ima[0] . $active_image . "." . $ima[1] . '\'" />';
						}
					} else {
						$image = '<img src="'. $mosConfig_live_site .'/images/stories/'. $ima[0] . $active_image . "." . $ima[1] . '" border="0" alt="'. $mitem->name . '" onmouseover="javascript:this.src=\'' .$mosConfig_live_site. '/images/stories/' . $ima[0] . $this->_image_suffix_hover . "." . $ima[1] . '\'" onmouseout="javascript:this.src=\'' .$mosConfig_live_site. '/images/stories/' . $ima[0] . $active_image . "." . $ima[1] . '\'" />';
					}
					$txt = $image;
				} else {
					$txt = $mitem->name;
				}
			} else {
				if($this->_display_image_on_sub_menu_dropline == 1) {
					if($this->_display_image_with_text_on_sub_menu_dropline == 1) {
						if($this->_image_position_on_sub_menu_dropline == "left") {
							$image = '<img src="'. $mosConfig_live_site .'/images/stories/'. $ima[0] . $active_image . "." . $ima[1] . '" border="0" alt="'. $mitem->name . '" onmouseover="javascript:this.src=\'' .$mosConfig_live_site. '/images/stories/' . $ima[0] . $this->_image_suffix_hover . "." . $ima[1] . '\'" onmouseout="javascript:this.src=\'' .$mosConfig_live_site. '/images/stories/' . $ima[0] . $active_image . "." . $ima[1] . '\'" />' . $mitem->name;
						} else {
							$image = $mitem->name . '<img src="'. $mosConfig_live_site .'/images/stories/'. $ima[0] . $active_image . "." . $ima[1] . '" border="0" alt="'. $mitem->name . '" onmouseover="javascript:this.src=\'' .$mosConfig_live_site. '/images/stories/' . $ima[0] . $this->_image_suffix_hover . "." . $ima[1] . '\'" onmouseout="javascript:this.src=\'' .$mosConfig_live_site. '/images/stories/' . $ima[0] . $active_image . "." . $ima[1] . '\'" />';
						}
					} else {
						$image = '<img src="'. $mosConfig_live_site .'/images/stories/'. $ima[0] . $active_image . "." . $ima[1] . '" border="0" alt="'. $mitem->name . '" onmouseover="javascript:this.src=\'' .$mosConfig_live_site. '/images/stories/' . $ima[0] . $this->_image_suffix_hover . "." . $ima[1] . '\'" onmouseout="javascript:this.src=\'' .$mosConfig_live_site. '/images/stories/' . $ima[0] . $active_image . "." . $ima[1] . '\'" />';
					}
					$txt = $image;
				} else {
					$txt = $mitem->name;
				}
			}
	  } else {
			$txt = $mitem->name;
		}
		return $txt;
	}

	//return 0 if menu is text only, return 1 if meny is image only, return 2 if menu is text and image
	function isFullImageMenu($mitem, $level){
		global $Itemid,$mosConfig_live_site;
		$menu_params = new stdClass();
		$menu_params = new mosParameters( $mitem->params );
		$menu_image = $menu_params->def( 'menu_image', -1 );
		if ( ( $menu_image != '-1' ) && $menu_image && (strlen($menu_image)>0)) {
			if($level == 1) {
				if($this->_display_image_on_top_menu_dropline == 1) {
					if($this->_display_image_with_text_on_top_menu_dropline == 1) {
						return 2;
					} else {
						return 1;
					}
				} else {
					return 0;
				}
			} else {
				if($this->_display_image_on_sub_sub_dropline == 1) {
					if($this->_display_image_with_text_on_sub_menu_dropline == 1) {
						return 2;
					} else {
						return 1;
					}
				} else {
					return 0;
				}
			}
		} else {
			return 0;
		}
	}
  
  function display() {
    return $this->_output;
  }
}

?>